diff -r 3da9153bcf2d -r 0324c269b390 javafx-beans/src/javafx/collections/ObservableArray.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/javafx-beans/src/javafx/collections/ObservableArray.java	Mon Apr 22 15:45:02 2013 -0700
@@ -0,0 +1,165 @@
+/*
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package javafx.collections;
+
+
+import com.sun.javafx.collections.ArrayListenerHelper;
+import javafx.beans.InvalidationListener;
+import javafx.beans.Observable;
+import javafx.beans.property.IntegerProperty;
+import javafx.beans.property.ReadOnlyIntegerProperty;
+import javafx.beans.property.ReadOnlyIntegerWrapper;
+import javafx.beans.property.SimpleIntegerProperty;
+import javafx.beans.value.ChangeListener;
+import javafx.beans.value.ObservableValue;
+
+
+/**
+ *
+ * @author akouznet
+ */
+public abstract class ObservableArray<T extends ObservableArray> implements Observable {
+    
+    private final int componentsPerElement;
+    protected ArrayListenerHelper<T> listenerHelper;
+
+    public ObservableArray() {
+        this.componentsPerElement = 1;
+    }
+    
+    public ObservableArray(int COMPONENTS_PER_ELEMENT) {
+        this.componentsPerElement = COMPONENTS_PER_ELEMENT;
+    }
+
+    /**
+     * Length of data in this array. Is less or equal to an array length.
+     * Setting different size will force {@code ObservableArray} to create array
+     * of given size and copy existing data into it. To avoid data copying 
+     * set size to 0 before setting it to new value.
+     */
+    private final IntegerProperty size = new SimpleIntegerProperty(this, "size");
+    private boolean ignoreSizeChange = false;
+    
+    {
+        size.addListener(new ChangeListener<Number>() {
+
+            @Override public void changed(ObservableValue<? extends Number> observable, Number oldValue, Number newValue) {
+                if (!ignoreSizeChange) {
+                    resizeArray(oldValue.intValue(), newValue.intValue());
+                }
+            }
+        });
+    }
+    
+    /**
+     * This method should resize array and copy existing elements into it
+     * @param oldSize old size of data in array
+     * @param newSize new size of data in array
+     */
+    protected abstract void resizeArray(int oldSize, int newSize);
+    
+    /**
+     * This method allows the change array size not causing resizeArray method to be invoked.
+     * @param newSize new array size
+     * @param ignoreSizeChange if true then new size value is just stored in the property,
+     * otherwise resizeArray method is invoked
+     */
+    protected void setSize(int newSize, boolean ignoreSizeChange) {
+        this.ignoreSizeChange = ignoreSizeChange;
+        size.set(newSize);
+        this.ignoreSizeChange = false;
+    }
+    
+    /**
+     * Sets new length of data in this array. This method creates new array
+     * if necessary and copies existing data into it. To avoid data copying 
+     * set size to 0 before setting it to new value.
+     */
+    public void setSize(int value) {
+        size.set(value);
+    }
+
+    /**
+     * Retrieves length of this array
+     * @return array length
+     */
+    public final int size() {
+        return size.get();
+    }
+
+    public IntegerProperty sizeProperty() {
+        return size;
+    }
+
+    /**
+     * Checks that the given length is divisible by components_per_element
+     * @return true if it is divisible; false otherwise
+     */
+    protected boolean verifyLength(int length) {
+        return length % componentsPerElement == 0;
+    }    
+    
+    private ReadOnlyIntegerWrapper elementCount;
+
+    public ReadOnlyIntegerProperty elementCountProperty() {
+        if (elementCount == null) {
+            elementCount = new ReadOnlyIntegerWrapper(this, "elementCount");
+            elementCount.bind(sizeProperty().divide(componentsPerElement));
+        }
+        return elementCount.getReadOnlyProperty();
+    }
+    
+    /**
+     * The total number of elements of this {@code ObservableArray}
+     * This is {@code size() / COMPONENTS_PER_ELEMENT}.
+     */
+    public int getElementCount() {
+        return size() / componentsPerElement;
+    }
+    
+    /**
+     * @return Number of components per element. For example, 3D point has 
+     * 3 components per element: x, y, z.
+     */
+    public int getComponentsPerElement() {
+        return componentsPerElement;
+    }
+
+    @Override public void addListener(InvalidationListener listener) {
+        listenerHelper = ArrayListenerHelper.addListener(listenerHelper, this, listener);
+    }
+
+    @Override public void removeListener(InvalidationListener listener) {
+        listenerHelper = ArrayListenerHelper.removeListener(listenerHelper, listener);
+    }
+    
+    public void addListener(ArrayChangeListener listener) {
+        listenerHelper = ArrayListenerHelper.addListener(listenerHelper, this, listener);
+    }
+
+    public void removeListener(ArrayChangeListener listener) {
+        listenerHelper = ArrayListenerHelper.removeListener(listenerHelper, listener);
+    }
+}
\ No newline at end of file
diff -r 3da9153bcf2d -r 0324c269b390 javafx-beans/src/javafx/collections/ObservableFloatArray.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/javafx-beans/src/javafx/collections/ObservableFloatArray.java	Mon Apr 22 15:45:02 2013 -0700
@@ -0,0 +1,152 @@
+/*
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package javafx.collections;
+
+import com.sun.javafx.collections.ArrayListenerHelper;
+
+
+/**
+ *
+ * @author akouznet
+ */
+public class ObservableFloatArray extends ObservableArray<ObservableFloatArray> {
+    
+    private float[] array;
+
+    public ObservableFloatArray() {
+    }
+    
+    public ObservableFloatArray(int COMPONENTS_PER_ELEMENT) {
+        super(COMPONENTS_PER_ELEMENT);
+    }
+
+    /**
+     * Sets the array of this {@code TriangleMesh}
+     * 
+     * @param array source array of components_per_element * n values containing n new array.
+     */
+    public final void set(float[] array) {
+        if (!verifyLength(array.length)) {
+            throw new IllegalArgumentException("array.length has to be divisible by " + getComponentsPerElement() + ".");
+        }
+        boolean sizeChanged = this.array == null || this.array.length != array.length;
+
+        if ((this.array == null) || (this.array.length < array.length)) {
+            this.array = new float[array.length];
+        }
+        System.arraycopy(array, 0, this.array, 0, array.length);
+        // Store the valid elements count.
+        // Note this.array.length can be bigger than array.length.
+        setSize(array.length, true);
+        
+        ArrayListenerHelper.fireValueChangedEvent(listenerHelper, sizeChanged, 0, size());
+    }
+    
+    /**
+     * Sets the array associated with this {@code FloatArray}
+     * starting at the specified {@code index} using data in {@code array} 
+     * starting at index {@code start} for {@code length} number of array.
+     * 
+     * @param index the starting destination index in this TriangleMesh's array array
+     * @param array source array of floats containing the new array
+     * @param start starting source index in the array array.
+     * @param length number of point elements to be copied.
+     */
+    public final void set(int index, float[] array,
+                      int start, int length) {
+
+        System.arraycopy(array, start, this.array, index, length);
+
+        ArrayListenerHelper.fireValueChangedEvent(listenerHelper, false, index, index + length);
+    }
+    
+    public final float[] get() {
+        return toArray(null);
+    }
+    
+    /**
+     * Gets the array of this {@code TriangleMesh}
+     *
+     * @param array a float array that will receive the array
+     * if it not null and has sufficient capacity.
+     * @return a float array of array
+     */
+    public final float[] toArray(float[] array) {
+        if (this.array == null) {
+            return null;
+        }
+        if ((array == null) || (size() > array.length)) {
+            array = new float[size()];
+        }
+        System.arraycopy(this.array, 0, array, 0, size());
+        return array;
+    }
+    
+    public final float getValue(int index) {
+        return array[index];
+    }
+    
+    public final void setValue(int index, float value) {
+        array[index] = value;
+        ArrayListenerHelper.fireValueChangedEvent(listenerHelper, false, index, index + 1);
+    }
+
+    /**
+     * Gets the array associated with this {@code TriangleMesh} starting at the
+     * specified {@code index} for {@code length} number of array.
+     * 
+     * @param index starting source array index in this {@code TriangleMesh}
+     * @param array destination array that will receive this {@code TriangleMesh}'s array data
+     * @param length number of point elements to be copied
+     * @return a float array
+     */
+    public final float[] toArray(int index, float[] array, int length) {
+        if (this.array == null) {
+            return null;
+        }
+        System.arraycopy(this.array, index, array, 0, length);
+        return array;
+    }
+    
+    public final void copyTo(int srcPos, float[] dest, int destPos, int length) {
+        if (this.array == null) {
+            return;
+        }
+        System.arraycopy(this.array, srcPos, dest, destPos, length);
+    }
+
+    @Override
+    protected void resizeArray(int oldSize, int newSize) {
+        int minSize = Math.min(oldSize, newSize);
+        if (array == null) {
+            array = new float[newSize];
+        } else if (array.length != newSize) {
+            float[] newArray = new float[newSize];
+            System.arraycopy(array, 0, newArray, 0, minSize);
+            array = newArray;
+        }
+        ArrayListenerHelper.fireValueChangedEvent(listenerHelper, oldSize != newSize, minSize, minSize);
+    }
+}
\ No newline at end of file
diff -r 3da9153bcf2d -r 0324c269b390 javafx-beans/src/javafx/collections/ObservableIntegerArray.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/javafx-beans/src/javafx/collections/ObservableIntegerArray.java	Mon Apr 22 15:45:02 2013 -0700
@@ -0,0 +1,157 @@
+/*
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package javafx.collections;
+
+import com.sun.javafx.collections.ArrayListenerHelper;
+
+
+/**
+ *
+ * @author akouznet
+ */
+public class ObservableIntegerArray extends ObservableArray<ObservableIntegerArray> {
+    
+    private int[] array;
+
+    public ObservableIntegerArray() {
+    }
+    
+    public ObservableIntegerArray(int COMPONENTS_PER_ELEMENT) {
+        super(COMPONENTS_PER_ELEMENT);
+    }
+    
+    /**
+     * Sets the array, indices into the points and texCoords arrays,
+     * associated with this {@code TriangleMesh}.
+     * 
+     * @param array source array of components_per_element * n indices 
+     * (3 point indices and 3 texCood indices) containing n new array
+     */
+    public final void set(int[] array) {
+        if (!verifyLength(array.length)) {
+            throw new IllegalArgumentException("array.length has to be divisible by " + getComponentsPerElement() + ".");
+        }
+        boolean sizeChanged = this.array == null || this.array.length != array.length;
+        if ((this.array == null) || (this.array.length < array.length)) {
+            this.array = new int[array.length];
+        }
+        System.arraycopy(array, 0, this.array, 0, array.length);
+        // Store the valid face count.
+        // Note this.array.length can be bigger than array.length.
+        setSize(array.length, true);
+
+        ArrayListenerHelper.fireValueChangedEvent(listenerHelper, sizeChanged, 0, size());
+    }
+
+    /**
+     * Sets the array, indices into the points and texCoords arrays, 
+     * associated with this {@code TriangleMesh}
+     * starting at the specified{@code index} using data in {@code array} 
+     * starting at index {@code start} for {@code length} number of array.
+     * 
+     * @param index the starting destination index in this TriangleMesh's array array
+     * @param array an int array containing the new interleaved vertices
+     * @param start starting source index in the array array.
+     * @param length number of interleaved vertex elements to be copied
+     */
+    public final void set(int index, int[] array, int start, int length) {
+        
+        System.arraycopy(array, start, this.array, index, length);
+
+        ArrayListenerHelper.fireValueChangedEvent(listenerHelper, false, index, index + length);
+    }
+
+    public final int[] get() {
+        return toArray(null);
+    }
+    
+    /**
+     * Gets the array, indices into the points and texCoords arrays, of this 
+     * {@code TriangleMesh}
+     *
+     * @param array an int array that will receive the array if it not null and 
+     * has sufficient capacity.
+     * @return an int array of array
+     * 
+     */
+    public final int[] toArray(int[] array) {
+        if (this.array == null) {
+            return null;
+        }
+        if ((array == null) || (size() > array.length)) {
+            array = new int[size()];
+        }
+        System.arraycopy(this.array, 0, array, 0, size());
+        return array;
+    }
+    
+    public final int getValue(int index) {
+        return array[index];
+    }
+
+    public final void setValue(int index, int value) {
+        array[index] = value;
+        ArrayListenerHelper.fireValueChangedEvent(listenerHelper, false, index, index + 1);
+    }
+
+    
+    /**
+     * Gets the array, indices into the points and texCoords arrays,
+     * associated with this {@code TriangleMesh} starting at the specified
+     * {@code index} for {@code length} number of array.
+     * 
+     * @param index starting source array index in this {@code TriangleMesh}
+     * @param array destination array that will receive this {@code TriangleMesh}'s array data
+     * @param length number of face elements to be copied
+     * @return an int array
+     */
+    public final int[] toArray(int index, int[] array, int length) {
+        if (this.array == null) {
+            return null;
+        }
+        System.arraycopy(this.array, index, array, 0, length);
+        return array;
+    }    
+    
+    public final void copyTo(int srcPos, int[] dest, int destPos, int length) {
+        if (this.array == null) {
+            return;
+        }
+        System.arraycopy(this.array, srcPos, dest, destPos, length);
+    }   
+
+    @Override
+    protected void resizeArray(int oldSize, int newSize) {
+        int minSize = Math.min(oldSize, newSize);
+        if (array == null) {
+            array = new int[newSize];
+        } else if (array.length != newSize) {
+            int[] newArray = new int[newSize];
+            System.arraycopy(array, 0, newArray, 0, minSize);
+            array = newArray;
+        }
+        ArrayListenerHelper.fireValueChangedEvent(listenerHelper, oldSize != newSize, minSize, minSize);
+    }    
+}
diff -r 3da9153bcf2d -r 0324c269b390 javafx-fxml/src/com/sun/javafx/fxml/builder/TriangleMeshBuilder.java
--- a/javafx-fxml/src/com/sun/javafx/fxml/builder/TriangleMeshBuilder.java	Mon Apr 22 17:59:31 2013 +0100
+++ b/javafx-fxml/src/com/sun/javafx/fxml/builder/TriangleMeshBuilder.java	Mon Apr 22 15:45:02 2013 -0700
@@ -45,7 +45,7 @@
     public TriangleMesh build() {
         TriangleMesh mesh = new TriangleMesh(points, texCoords, faces);
         if (faceSmoothingGroups != null) {
-            mesh.setFaceSmoothingGroups(faceSmoothingGroups);
+            mesh.getFaceSmoothingGroups().set(faceSmoothingGroups);
         }
         return mesh;
     }
diff -r 3da9153bcf2d -r 0324c269b390 javafx-sg-common/src/com/sun/javafx/sg/PGTriangleMesh.java
--- a/javafx-sg-common/src/com/sun/javafx/sg/PGTriangleMesh.java	Mon Apr 22 17:59:31 2013 +0100
+++ b/javafx-sg-common/src/com/sun/javafx/sg/PGTriangleMesh.java	Mon Apr 22 15:45:02 2013 -0700
@@ -25,16 +25,17 @@
 
 package com.sun.javafx.sg;
 
+
+import com.sun.javafx.collections.FloatArraySyncer;
+import com.sun.javafx.collections.IntegerArraySyncer;
+
+
 /**
  * TODO: 3D - Need documentation
  */
 public interface PGTriangleMesh {
-    public void setPoints(float[] points);
-    public void setPoints(float[] points, int index, int length);
-    public void setTexCoords(float[] texCoords);
-    public void setTexCoords(float[] texCoords, int index, int length);
-    public void setFaces(int[] faces);
-    public void setFaces(int[] faces, int index, int length);
-    public void setFaceSmoothingGroups(int[] faceSmoothingGroups);
-    public void setFaceSmoothingGroups(int[] faceSmoothingGroups, int index, int length);
+    public void syncPoints(FloatArraySyncer array);
+    public void syncTexCoords(FloatArraySyncer array);
+    public void syncFaces(IntegerArraySyncer array);
+    public void syncFaceSmoothingGroups(IntegerArraySyncer array);
 }
diff -r 3da9153bcf2d -r 0324c269b390 javafx-sg-prism/src/com/sun/javafx/sg/prism/NGTriangleMesh.java
--- a/javafx-sg-prism/src/com/sun/javafx/sg/prism/NGTriangleMesh.java	Mon Apr 22 17:59:31 2013 +0100
+++ b/javafx-sg-prism/src/com/sun/javafx/sg/prism/NGTriangleMesh.java	Mon Apr 22 15:45:02 2013 -0700
@@ -25,10 +25,13 @@
 
 package com.sun.javafx.sg.prism;
 
+
+import com.sun.javafx.collections.FloatArraySyncer;
+import com.sun.javafx.collections.IntegerArraySyncer;
 import com.sun.javafx.sg.PGTriangleMesh;
 import com.sun.prism.Mesh;
 import com.sun.prism.ResourceFactory;
-import javafx.scene.shape.TriangleMesh;
+
 
 /**
  * TODO: 3D - Need documentation
@@ -99,109 +102,28 @@
         this.faceSmoothingGroups = faceSmoothingGroups;
     }
 
-    public void setPoints(float[] points) {
+    public void syncPoints(FloatArraySyncer array) {
         meshDirty = true;
-        if (points == null) {
-            this.points = null;
-            return;
-        }
-        if ((this.points == null) || (this.points.length != points.length)) {
-            this.points = new float[points.length];
-        }
-        System.arraycopy(points, 0, this.points, 0, this.points.length);      
+        points = array.syncTo(points);
+    }
+    
+    public void syncTexCoords(FloatArraySyncer array) {
+        meshDirty = true;
+        texCoords = array.syncTo(texCoords);
     }
 
-    public void setPoints(float[] points, int index, int length) {
+    public void syncFaces(IntegerArraySyncer array) {
         meshDirty = true;
-        if (points == null) {
-            this.points = null;
-            return;
-        }
-
-        // Range check were done in the FX layer.
-        int indexOffset = index * TriangleMesh.NUM_COMPONENTS_PER_POINT;
-        int lengthInFloatUnit = length * TriangleMesh.NUM_COMPONENTS_PER_POINT;
-        System.arraycopy(points, indexOffset, this.points, indexOffset, lengthInFloatUnit);
+        faces = array.syncTo(faces);    
     }
 
-    public void setTexCoords(float[] texCoords) {
+    public void syncFaceSmoothingGroups(IntegerArraySyncer array) {
         meshDirty = true;
-        if (texCoords == null) {
-            this.texCoords = null;
-            return;
-        }
-        if ((this.texCoords == null) || (this.texCoords.length != texCoords.length)) {
-            this.texCoords = new float[texCoords.length];
-        }
-        System.arraycopy(texCoords, 0, this.texCoords, 0, this.texCoords.length);
-    }
-
-    public void setTexCoords(float[] texCoords, int index, int length) {
-        meshDirty = true;
-        if (texCoords == null) {
-            this.texCoords = null;
-            return;
-        }
-
-        // Range check were done in the FX layer.
-        int indexOffset = index * TriangleMesh.NUM_COMPONENTS_PER_TEXCOORD;
-        int lengthInFloatUnit = length * TriangleMesh.NUM_COMPONENTS_PER_TEXCOORD;
-        System.arraycopy(texCoords, indexOffset, this.texCoords, indexOffset, lengthInFloatUnit);
-    }
-
-    public void setFaces(int[] faces) {
-        meshDirty = true;
-        if (faces == null) {
-            this.faces = null;
-            return;
-        }
-        if ((this.faces == null) || (this.faces.length != faces.length)) {
-            this.faces = new int[faces.length];
-        }
-        System.arraycopy(faces, 0, this.faces, 0, this.faces.length);
-    }
-
-    public void setFaces(int[] faces, int index, int length) {
-        meshDirty = true;
-        if (faces == null) {
-            this.faces = null;
-            return;
-        }
-
-        // Range check were done in the FX layer.
-        int indexOffset = index * TriangleMesh.NUM_COMPONENTS_PER_FACE;
-        int lengthInIntUnit = length * TriangleMesh.NUM_COMPONENTS_PER_FACE;
-        System.arraycopy(faces, indexOffset, this.faces, indexOffset, lengthInIntUnit);
-    }
-
-    public void setFaceSmoothingGroups(int[] faceSmoothingGroups) {
-        meshDirty = true;
-        if (faceSmoothingGroups == null) {
-            this.faceSmoothingGroups = null;
-            return;
-        }
-        if ((this.faceSmoothingGroups == null) || 
-                (this.faceSmoothingGroups.length != faceSmoothingGroups.length)) {
-            this.faceSmoothingGroups = new int[faceSmoothingGroups.length];
-        }
-
-        System.arraycopy(faceSmoothingGroups, 0, this.faceSmoothingGroups, 0,
-                this.faceSmoothingGroups.length);
-    }
-
-    public void setFaceSmoothingGroups(int[] faceSmoothingGroups, int index, int length) {
-        meshDirty = true;
-        if (faceSmoothingGroups == null) {
-            this.faceSmoothingGroups = null;
-            return;
-        }
-
-        // Range check were done in the FX layer.
-        System.arraycopy(faceSmoothingGroups, index, this.faceSmoothingGroups, index, length);
+        faceSmoothingGroups = array.syncTo(faceSmoothingGroups);
     }
 
     // NOTE: This method is used for unit test purpose only.
-    int[] test_getFaceSmoothingGroups() {
+    int[] test_getShiftedFaceSmoothingGroups() {
         return this.faceSmoothingGroups;
     }
 }
diff -r 3da9153bcf2d -r 0324c269b390 javafx-ui-common/src/javafx/scene/shape/Box.java
--- a/javafx-ui-common/src/javafx/scene/shape/Box.java	Mon Apr 22 17:59:31 2013 +0100
+++ b/javafx-ui-common/src/javafx/scene/shape/Box.java	Mon Apr 22 15:45:02 2013 -0700
@@ -387,8 +387,7 @@
             0, 0, 1, 1, 4, 2, 4, 2, 1, 1, 5, 3, 2, 0, 6, 2, 3, 1, 3, 1, 6, 2, 7, 3,
             0, 0, 4, 1, 2, 2, 2, 2, 4, 1, 6, 3, 1, 0, 3, 1, 5, 2, 5, 2, 3, 1, 7, 3,};
 
-        TriangleMesh mesh = new TriangleMesh(points, texCoords, faces);
-        mesh.setFaceSmoothingGroups(faceSmoothingGroups);
+        TriangleMesh mesh = new TriangleMesh(points, texCoords, faces, faceSmoothingGroups);
 
         return mesh;
     }
diff -r 3da9153bcf2d -r 0324c269b390 javafx-ui-common/src/javafx/scene/shape/Cylinder.java
--- a/javafx-ui-common/src/javafx/scene/shape/Cylinder.java	Mon Apr 22 17:59:31 2013 +0100
+++ b/javafx-ui-common/src/javafx/scene/shape/Cylinder.java	Mon Apr 22 15:45:02 2013 -0700
@@ -489,8 +489,7 @@
             smoothing[i] = 2;
         }
 
-        TriangleMesh m = new TriangleMesh(points, tPoints, faces);
-        m.setFaceSmoothingGroups(smoothing);
+        TriangleMesh m = new TriangleMesh(points, tPoints, faces, smoothing);
 
         return m;
     }
diff -r 3da9153bcf2d -r 0324c269b390 javafx-ui-common/src/javafx/scene/shape/Sphere.java
--- a/javafx-ui-common/src/javafx/scene/shape/Sphere.java	Mon Apr 22 17:59:31 2013 +0100
+++ b/javafx-ui-common/src/javafx/scene/shape/Sphere.java	Mon Apr 22 15:45:02 2013 -0700
@@ -402,8 +402,7 @@
             smoothing[i] = 1;
         }
 
-        TriangleMesh m = new TriangleMesh(points, tPoints, faces);
-        m.setFaceSmoothingGroups(smoothing);
+        TriangleMesh m = new TriangleMesh(points, tPoints, faces, smoothing);
         return m;
     }
 
